#include <someFunc.h>
#include <iostream>

void someFunc(BaseClass* bC) { //We can take the BaseClass as a function parameter, Which also allows us to accept any of the derived classes.
    if (auto* dc1 = dynamic_cast<DerivedClass1*>(bC)) { //If we passed in DerivedClass1.
        std::cout << "You passed in "; dc1->printClassName(); //The overridden version of the function from DerivedClass1 will run.
        return; //Exit the void function early.
    }

    if (auto* dc2 = dynamic_cast<DerivedClass2*>(bC)) {
        std::cout << "You passed in "; dc2->printClassName();
        return;
    }

    if (auto* b = dynamic_cast<BaseClass*>(bC)) //If we passed in the base class and not any derived class.
                                                //*Must* be checked for last if you'll be passing in BaseClass because this will always succeed.
        std::cout << "You passed in ", b->printClassName();
}
